# Castorcito

## Process of upgrading from 1.0.0-alpha1 to latest

- Install config_delete module
- Delete config REST resource block_list_resource
- Upgrade to latest version with composer or git if use dev version
- Go to /update.php

## Installing JSON Editor with composer

One of the dependencies of this module is [json_field], this module adds a solution for adding jsoneditor to a site using Composer.
This solution can be found in the [README.md] of the [json_field] module in the "Installing JSON Editor with composer" section.

## Getting started

To make it easy for you to get started with GitLab, here's a list of recommended next steps.

Already a pro? Just edit this README.md and make it your own. Want to make it easy? [Use the template at the bottom](#editing-this-readme)!

## Add your files

- [ ] [Create](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#create-a-file) or [upload](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#upload-a-file) files
- [ ] [Add files using the command line](https://docs.gitlab.com/ee/gitlab-basics/add-file.html#add-a-file-using-the-command-line) or push an existing Git repository with the following command:

```
cd existing_repo
git remote add origin https://gitlab.com/softwinteam/castorcito.git
git branch -M main
git push -uf origin main
```

## Integrate with your tools

- [ ] [Set up project integrations](https://gitlab.com/softwinteam/castorcito/-/settings/integrations)

## Collaborate with your team

- [ ] [Invite team members and collaborators](https://docs.gitlab.com/ee/user/project/members/)
- [ ] [Create a new merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html)
- [ ] [Automatically close issues from merge requests](https://docs.gitlab.com/ee/user/project/issues/managing_issues.html#closing-issues-automatically)
- [ ] [Enable merge request approvals](https://docs.gitlab.com/ee/user/project/merge_requests/approvals/)
- [ ] [Set auto-merge](https://docs.gitlab.com/ee/user/project/merge_requests/merge_when_pipeline_succeeds.html)

## Test and Deploy

Use the built-in continuous integration in GitLab.

- [ ] [Get started with GitLab CI/CD](https://docs.gitlab.com/ee/ci/quick_start/index.html)
- [ ] [Analyze your code for known vulnerabilities with Static Application Security Testing (SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)
- [ ] [Deploy to Kubernetes, Amazon EC2, or Amazon ECS using Auto Deploy](https://docs.gitlab.com/ee/topics/autodevops/requirements.html)
- [ ] [Use pull-based deployments for improved Kubernetes management](https://docs.gitlab.com/ee/user/clusters/agent/)
- [ ] [Set up protected environments](https://docs.gitlab.com/ee/ci/environments/protected_environments.html)
# Managing templates with Castorcito module

This module create a formatter to be used in a JSON field.
- First, in managed form display we have to select the option "Castorcito Component" and configurate the component that will be able to this field.
- After that, in managed display we have to select the formatter "Castorcito component" and save that.

This options have to be configurated to templates are able in the site.

The template is defined trought the formatter created by this module. The template is located in the following module's directory:

```
/templates/field--castorcito-component-formatter.html.twig
```

Inside this template there's validations and loops to managed the includes to call and render the right field. Every field has a basic html markup inside its template fil. This is located in the following directory:

```
/templates/components/fields/castorcito_field-name.html.twig
```

In the twig code, the "component_data" variable has all the information about every component used in this field.

## How to override this markup?

If you want to have a more particular and custom html markup we need to override this template in the theme that you want to see the changes. We recommended to follow the next directory path:

```
theme_name/templates/castorcito/field--castorcito-component-formatter.html.twig
```

Inside the template file we have the write the following html markup:

```
{% if component_data is not empty %}
  {% set component_type = component_data.type|clean_class %}
  <div class="c-component c-type--{{ component_type }}">
    {% include ['@theme_name/castorcito/components/' ~ component_type ~ '/' ~ component_type ~ '.html.twig', '@castorcito/field--castorcito-component-formatter.html.twig'] %}
  </div>
{% endif %}
```
**Note:** The include line is calling a new component template in the current theme, is recommended to follow the structure.

Every new component have a related template and this has to be created in the following directory path:

```
theme_name/templates/castorcito/components/component_name/component_name.html.twig
```

In order to work using the single directory components concept, its posible to include in this directory some files related to the styles and behaviour.

```
theme_name/templates/castorcito/components/component_name/component_name.html.twig
theme_name/templates/castorcito/components/component_name/component_name.css
theme_name/templates/castorcito/components/component_name/component_name.js
```

If we need to use files like this is necessary to register them (see below code) in the file library in order to be able to use. The file is in: theme_name/theme_name.libraries.yml

```
component_name:
  css:
    theme:
      templates/castorcito/components/component_name/component_name.css: {}
  js:
    templates/castorcito/components/component_name/component_name.js: {}

``` 
    
To include the new library is necessary to add the following line inside the related template for this new component :
```
{{ attach_library('theme_name/component_name') }}
```

