<?php

namespace Drupal\castorcito\Plugin\Field\FieldFormatter;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Component\Serialization\Json;

/**
 * Plugin implementation of the 'castorcito_component_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "castorcito_component_formatter",
 *   label = @Translation("Castorcito component"),
 *   field_types = {
 *     "json",
 *     "json_native",
 *     "json_native_binary",
 *   }
 * )
 */
class CastorcitoComponentFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function settingsSummary() {
    $summary = [];
    $summary[] = $this->t('Displays castorcito components.');
    return $summary;
  }

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {

    $elements = [];
    $component_data_raw = [];

    $component_data = [];

    if (!empty($items)) {
      foreach ($items as $key => $item) {
        $component_data_raw[$key] = Json::decode($item->value);

        $component_data = $component_data_raw[$key];


        $castorcito_formatter_template = 'castorcito_component_formatter';

        $elements[] = [
          '#theme' => $castorcito_formatter_template,
          '#values' => $component_data_raw,
          '#component_data' => $component_data,
        ];
      }
    }

    return $elements;
  }

}
